Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.java.ao.schema
Interface FieldNameConverter

All Known Implementing Classes:
  AbstractFieldNameConverter, CamelCaseFieldNameConverter, UnderscoreFieldNameConverter

    public interface FieldNameConverter

Superinterface to all field name converters; designed to impose conventions upon the auto-conversion of method names to database fields. The idea behind this is to allow user-specified field name conventions and standards rather than always enforcing ActiveObjects's idea of "good naming".

Every `EntityManager` contains a single field name converter which the entire library uses when performing operations. Any third-party code which interacts with database fields can also make use of this class. However, it's significantly harder to do so because Java doesn't support method literals.

Most new implementations of field name converters should extend `AbstractFieldNameConverter` rather than implementing this interface directly. This allows third-party converters to take advantage of boiler-plate conversion code which would otherwise have to be duplicated in every converter.

Author:
  Daniel Spiewak

Method Summary
`String` | `getName(Method method)` Generates a field name to correspond with the specified method.
`String` | `getPolyTypeName(Method method)` Generates a secondary field name which corresponds with the polymorphic type flag for the field corresponding to the specified method.

Method Detail

### getName

    String getName(Method method)

  Generates a field name to correspond with the specified method. The algorithm used must not only be aware of the defined conventions (such as getters and setters) but also the annotations sometimes used to override the field name explicitly. AO will not test for these annotations separately from the field name converter.

  Parameters:
    `method` - The method for which a corresponding field name must be generated.
  Returns:
    A database field name which corresponds to the given method.

### getPolyTypeName

    String getPolyTypeName(Method method)

  Generates a secondary field name which corresponds with the polymorphic type flag for the field corresponding to the specified method. If the method in question does not represent a polymorphic field, this method may return any value, or `null`. For most use-cases, the return value of this method will be identical to that of the `getName(Method)` method with a conventional suffix (usually "Type" or "_type") to indicate that it is a polymorphic flag. Polymorphic fields are the only scenario in which two fields will correspond to a single method.

  An example of a table with a polymorphic flagging field could be taken as follows (MySQL DDL):

      CREATE TABLE comments (
           id INTEGER NOT NULL AUTO_INCREMENT,
           title VARCHAR(45),
           text TEXT,
           commentableID INTEGER,
           commentableType VARCHAR(255),
           PRIMARY KEY(id)
       );

  Notice the absence of foreign key constraint on the `commentableID` field. This is because this table has a one-to-many mapping with potentially numerous tables which can be described as "commentable". Thus, `commentableID` and `commentableType` describe a polymorphic one-to-many relationship within the database.

  Parameters:
    `method` - The method for which a corresponding field name must be generated.
  Returns:
    A database field name which corresponds to the given method.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007-2011. All Rights Reserved.